/*
 * file: tcp_server.h
 *
 * description:  this is the main header for the generic tcp server
 *   project.
 *
 * revision list:
 *   Fri Jun 26 14:04:53 EDT 1998 KRB - created file
 *
 *
 *
 */
#if !defined( _TCP_SERVER_H )
#define _TCP_SERVER_H

class pseudo_int
{
public:
  pseudo_int() : val(0) {;};                 // def constructor
  pseudo_int( const int& i ) : val(i) {;};   // copy constructor
  ~pseudo_int() {;};                         // destructor

  // comparison operators -- these are the only 2 that are needed, and
  // operator< is only needed for the sorted collection objects (c_map/c_hash),
  // and none of the others
  int operator<( const pseudo_int& that ) const { return val < that.val; };
  int operator==( const pseudo_int& that ) const { return val == that.val; };

  // assignment operator
  const pseudo_int& operator=( const pseudo_int& that ) {
    val = that.val;
    return *this;
  };

  // so it can be compared to an int
  friend int operator==( int i, const pseudo_int& x ) { return i == x.val; };

  int val;
};  


// this is needed for c_hash<pseudo_int,pseudo_int>
inline hash_value hash( int m, const pseudo_int n )
{
  return n.val % m;
}


#endif // !defined( _TCP_SERVER_H )
